#include <stdio.h>
#include <stdlib.h>

typedef union _ceo_realan{
	float realan; //ne mogu da se primene bitovski operatori
	unsigned long int ceo; //mogu da se primene bitovski operatori
}ceo_realan;

void print_bits(unsigned int x){
	int bc = sizeof(unsigned int) * 8;
	unsigned int mask = 1 << (bc - 1);
	
	int i;
	for(i = 0; i < bc; i++){
		unsigned int rez = mask & x;
		if(rez == 0)
			printf("0");
		else
			printf("1");
		mask = mask >> 1;
	}
	printf("\n");
}

unsigned int get_bit(unsigned int x, int k){
	unsigned int mask = 1 << k;
	unsigned rez = x & mask;
	if(rez == 0)
		return 0;
	else
		return 1;
}

unsigned int set_bit(unsigned int x, int k, int y){
	unsigned int mask = 1 << k;
	if(y == 1)
		return x | mask;
	else
		return x & (~mask);
}

int suma_bitova(unsigned int x){
	int suma = 0;
	int bc = sizeof(unsigned int) * 8;
	unsigned int mask = 1 << (bc - 1);
	
	int i;
	for(i = 0; i < bc; i++){
		unsigned int rez = mask & x;
		if(rez != 0)
			suma++;
		mask = mask >> 1;
	}
	return suma;
}

unsigned get_bits(unsigned x, int k, int n){
	unsigned rez;
	//x1 x2 x3
	//0   1  0
	//radimo logicko i, pa onda >>k
	
	unsigned mask = ~0; //11111111111111
	mask = mask << n;   //11111111110000  n nula
	mask = ~mask;       //00000000001111  n jedinica
	mask = mask << k;   //00000011110000
	
	//unsigned mask = (~((~0) << n)) << k;
	rez = (x & mask) >> k;
	return rez;
}

unsigned set_bits(unsigned x, int k, int n, unsigned y){
	unsigned mask_x = ~((~((~0) << n)) << k);
	unsigned mask_y = ~((~0) << n);
	y = (y & mask_y) << k;
	x = x & mask_x;
	return x | y;
}

unsigned invert_bits(unsigned x, int k, int n){
	unsigned mask = (~((~0) << n)) << k;
	return mask ^ x;
}

int main(){
	ceo_realan a;
	unsigned x = 12345678;
	print_bits(15);
	print_bits(999);
	print_bits(1024);
	print_bits(-123);
	print_bits(12345678);

	printf("%d %d\n", get_bit(12345678, 3), get_bit(12345678, 4));
	x = set_bit(x, 2, 0);
	x = set_bit(x, 29, 1);
	print_bits(x);
	
	printf("%d\n", suma_bitova(12345678));
	print_bits(12345678);
	print_bits(get_bits(12345678, 10, 10));
	
	print_bits(set_bits(43690, 3, 5, 1023));
	print_bits(12345678);
	print_bits(invert_bits(12345678, 10, 10));
	
	a.realan = -1234e13;
	print_bits(a.ceo);
	
	a.realan = 1234e-13;
	print_bits(a.ceo);
	
}